Index: squid/src/HintCacheHier.c
diff -u /dev/null squid/src/HintCacheHier.c:1.1.2.2
--- /dev/null	Mon Jan 26 04:57:38 2004
+++ squid/src/HintCacheHier.c	Mon May 20 19:46:41 2002
@@ -0,0 +1,755 @@
+/*
+ * $Date: 2004/08/17 20:55:13 $ $Id: squid-push-HEAD,v 1.1 2004/08/17 20:55:13 hno Exp $
+ *
+ * AUTHOR: Mike Dahlin, UT Austin, 1998
+ * DEBUG:  section 86,  Hint cache hierarchy.
+ *
+ * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
+ * --------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from the
+ *  Internet community.  Development is led by Duane Wessels of the
+ *  National Laboratory for Applied Network Research and funded by
+ *  the National Science Foundation.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *  
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *  
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  
+ */
+/*
+ *------------------------------------------------------------------
+ *
+ * LESS Group
+ * Computer Sciences Department 
+ * University of Texas at Austin
+ *
+ * HCDisk ---
+ *          The on-disk cache of hints. The key data structure
+ *          is an mmapped array which is treated as a <entriesPerBucket>-
+ *          associative cache.
+ * 
+ *------------------------------------------------------------------
+ */
+#include "squid.h"
+
+/*
+ * MDD 7.18.1998 
+ * We use a primitive hierarchy consisting of the edges 
+ * listed in the config file for bootstrapping the real 
+ * hierarchy. Each node floods Join/Leave events to
+ * neighbors on the peerlist. The peerlist initially comes from
+ * the config file cache_host entries. We add one thing:
+ * if node A lists B as a cache host to which it will
+ * propagate Join/Leave events, we also want B to have
+ * A on the peerlist. E.g., make all peerlist edges bidirectional
+ * even if the config file's don't make them bidirectional.
+ * The reason for this is that if a new node that no current
+ * nodes have ever heard of joins the system, we of course want to 
+ * propagate membership information to it. E.g, if node D
+ * adds node A to its config file, that effectively also
+ * adds node D to A's config file. Otherwise the old nodes
+ * learn about the new node, but the new node doesn't learn
+ * about anything.
+ *
+ * We also need to help figure out the hierarchy for Plaxton's
+ * algorithm. Plaxton's algorithm figures out who the parents
+ * are, but it doesn't know who the children are. We observe
+ * messages to keep in sync. 
+ * On recv message:
+ *	recv parent msg from parent: process parent message
+ *	recv child msg from child: process child message
+ *	recv parent msg from !parent: send "I am not child" to parent;
+ *			drop message
+ *	recv child msg from !child: add child to child list;
+ *				process child message
+ *	recv "I am not child" from child: remove child
+ */
+
+#define HCHIER_DEBUG 86
+
+#ifdef DOTEST
+static int doTestBarrier(int barrier);
+static void writeTestBarrier(int barrier);
+static int readTestBarrier(int barrier);
+static void clearTestBarrier();
+static void testFindPeer(peer * p);
+static void testPlax(void);
+static void testCreateStuff(char *tag);
+static void testFind(void);
+static void testFindStuff(char *tag, const struct sockaddr_in *expect);
+#endif /* DOTEST */
+
+/*
+ * These must be an set of values each one greater than the
+ * last to define the series of states for the network test.
+ */
+#define BARRIER_START 1000
+#define BARRIER_READY 1001
+#define BARRIER_JOIN 1002
+#define BARRIER_JOIN2 1003
+#define BARRIER_NODELIST 1004
+#define BARRIER_CREATE_STUFF 1005
+#define BARRIER_CREATE_STUFF2 1006
+#define BARRIER_CREATE_STUFF3 1007
+#define BARRIER_PLAX 1008
+#define BARRIER_FIND 1009
+#define BARRIER_LAST 1010
+#define BARRIER_DONE 9999
+
+int HintCacheHier_selfTestDone = 0;
+
+
+dlink_list HintCacheHier_Nodes;
+
+int scanIDs (dlink_list * l, char *b, int *count);
+int scanIDDistances (dlink_list * l, char *b, int *count);
+
+void
+hintCacheHier_Init(void)
+{
+    HintCacheNodeListIter iter;
+    struct sockaddr_in saddr;
+    /*
+     * This should be set in config file
+     */
+    static int bitsPerLevelXXX = 8;
+
+    HintCacheNodelist_Init();
+    HintCachePlax_Init(bitsPerLevelXXX);
+    HintCacheNodelist_LocalJoin();
+    for (HintCacheNodeList_IterStart(&iter);
+	hintCacheNodeList_IterCheck(iter); hintCacheNodeList_IterNext(&iter)) {
+	if (hintCacheNodeList_IterGetAddr(iter, &saddr)) {
+	    hintCachePlax_addNode(&saddr);
+	}
+    }
+}
+
+void
+hintCacheHier_Destroy(void)
+{
+    hintCacheNodelist_LocalLeave();
+    hintCacheNodelist_Destroy();
+    hintCachePlax_Destroy();
+}
+
+/*
+ *------------------------------------------------------------------
+ * MDD 7.18.1998
+ *
+ * HCHier_updateMembershipNeighbor --
+ *
+ *          Add the specified node to the peerlist. See HCHier.h
+ *          for explanation.
+ *
+ * Arguments:
+ *      None.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *----------------------------------------------------7.18.1998---------
+ */
+void
+hintCacheHierUpdateMembershipNeighbor(struct sockaddr_in *neighbor,
+    NeighborAction action)
+{
+    /* Currently nothing */
+}
+
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheHierCompareDistanceFromMe --
+ *
+ *          Return <0 if new node is closer than old node, 0 if same
+ *          distance, >0 if new node is closer than old  node.
+ *          If either node is missing, it must be far away. If both
+ *          are missing, say new one is closer (0) (needed to make
+ *          initial sight of new host work).
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *------------------------------------------------------------------
+ */
+int
+hintCacheHierCompareDistanceFromMe(struct in_addr new, struct in_addr old)
+{
+    int nrtt, ortt;
+    int nhops, ohops;
+    char name[16];
+
+    /* Compare by rtt if both have measured rtts */
+    /* Must make copy of result of inet_ntoa before making
+     * function call because netdb also uses that function */
+    strcpy(name, inet_ntoa(new));
+    nrtt = netdbHostRtt(name);
+    strcpy(name, inet_ntoa(old));
+    ortt = netdbHostRtt(name);
+    if (nrtt && ortt)
+	return (nrtt - ortt);
+
+    /* Otherwise compare hopcount */
+    nhops = netdbHintHops(new);
+    ohops = netdbHintHops(old);
+
+    /* If either host is unknown, say new one is nearer */
+    if (nhops == 0 || ohops == 0)
+	return (-1);
+
+    return (nhops - ohops);
+}
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheHierNewNode --
+ *
+ *          This gets called when we hear about a new node in the system.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *-------------------------------------------------4.1.1998-----------
+ */
+void
+hintCacheHierNewNode(struct sockaddr_in *sin, int hops, long long joinTimeNS)
+{
+    hintCacheNodelist_NetJoin(sin, hops, joinTimeNS);
+}
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheHierDelNode --
+ *
+ *          This gets called when we hear about a node leaving the system
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *-------------------------------------------------4.1.1998-----------
+ */
+void
+hintCacheHierDelNode(struct sockaddr_in *sin, int hops, long long joinTimeNS)
+{
+    hintCacheNodelist_NetLeave(sin, hops, joinTimeNS);
+}
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheHierCheckIfParent --
+ *
+ *          See if the specified node is really my parent.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *---------------------------------------------------4.10.1998---------
+ */
+int
+hintCacheHierCheckIfParent(URLKey key, struct sockaddr_in *candidate)
+{
+#if USE_DYNAMIC_HIERARCHY
+    return hintCachePlax_CheckIfParent(key, candidate);
+#else
+    /* 
+     * For static algorithm, anyone that wants to be my parent can 
+     * be.
+     */
+    return 1;
+#endif
+}
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheHier_CheckIfChild --
+ *
+ *          See if the specified node is really my child.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *---------------------------------------------------4.10.1998---------
+ */
+int
+hintCacheHierCheckIfChild(struct sockaddr_in *candidate)
+{
+#if USE_DYNAMIC_HIERARCHY
+    return hintCachePlax_CheckIfChild(candidate);
+#else
+    /* 
+     * For static algorithm, anyone that wants to be my child can 
+     * be.
+     */
+    return 1;
+#endif
+}
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheHierAddChild --
+ *
+ *          This node has claimed to by my child, so add it
+ *          to the dynamic hierarchy.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *-----------------------------------------------------4.10.1998--------
+ */
+void
+hintCacheHierAddChild(struct sockaddr_in *child)
+{
+#if USE_DYNAMIC_HIERARCHY
+    hintCachePlax_AddChild(child);
+#else
+    /*
+     * For static algorithm, I don't track children.
+     */
+    return;
+#endif
+}
+
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheHierRemoveChild --
+ *
+ *          This node denies paternity. Disinherit it.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *---------------------------------------------------4.10.1998----------
+ */
+void
+hintCacheHierRemoveChild(struct sockaddr_in *child)
+{
+#if USE_DYNAMIC_HIERARCHY
+    hintCachePlax_RemoveChild(child);
+#else
+    /*
+     * For static algorithm, I don't track children.
+     */
+    return;
+#endif
+}
+
+
+/*
+ * Network enqueue/send interface.
+ */
+
+/*  Each children queue holds messages that should go to a set of
+ * "equivalent" children  (eg. the children at some level of the
+ * hierarchy.)  There are hintCacheHier_NChildrenQs() such queues;
+ * Child queue q contains c = hintCacheHier_ChildrenPerQ(q) children.
+ * The addresses of the children can be found with the function
+ * hintCacheHier_GetChildAddr(q, c);
+ *
+ * Each parent queue holds messages that should go to one parent.
+ * In general, we may have different parents for different objects.
+ * So, enqueue messages for an object in the queue
+ * hintCacheHier_ParentQIndex(URLKey).
+ */
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheHierChildQIndex --
+ *
+ *          Return the index into the array of queues of 
+ *          children for children that are my children 
+ *          for this object. (See hintCachePlax for how
+ *          children are grouped into levels.)
+ *
+ *          Also, if I have no children for this object,
+ *          set amILeaf to true.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *-----------------------------------------------4.10.1998-------------
+ */
+int
+hintCacheHierChildQIndex(URLKey * key, int iAmRoot, int *amILeaf)
+{
+    assert(amILeaf != NULL);
+#if USE_DYNAMIC_HIERARCHY
+    return hintCachePlax_ChildQIndex(key, iAmRoot, amILeaf);
+#else
+    /*
+     * For static algorithm, we have one set of children and
+     * thus one outgoing children buffer with index 0.
+     */
+    *amILeaf = 0;
+    return 0;
+#endif
+}
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheHierNChildrenQs --
+ *
+ *          Return the number of outgoing message queues
+ *          to different classes of children. Each
+ *          "class" corresponds to children for which 
+ *          I am a parent. (See hintCachePlax for how
+ *          children are grouped into levels.)
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *------------------------------------------------4.10.1998------------
+ */
+int
+hintCacheHierNChildrenQs(void)
+{
+#if USE_DYNAMIC_HIERARCHY
+    return hintCachePlax_NChildrenQs();
+#else
+    /*
+     * For static algorithm, we have one set of children and
+     * thus one outgoing children buffer with index 0.
+     */
+    return 1;
+#endif
+}
+
+
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheHierGetChildAddrs --
+ *
+ *        Return the number of children for the specified message
+ *        queue, allocate a buffer for that many addresses,
+ *        and fill in that bufer with the children's addresses.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      See above.
+ *
+ * Side effects:
+ *      Allocates a vector for the addresses. Caller must free
+ *      this vector when done.
+ *
+ *      Note: the vector may be out of date by the time ther caller
+ *      uses it. This is inherent problem -- even if caller sent
+ *      all messages instantaneously, by the time they arrive
+ *      at destination, the child could have left the system
+ *      or a new child could have joined.
+ *
+ *------------------------------------------------4.16.1998------------
+ */
+int
+hintCacheHierGetChildAddrs(int qIndex, struct sockaddr_in **retAddrAP)
+{
+#ifndef USE_DYNAMIC_HIERARCHY
+    peer *p;
+    int count = 0, nchildren = 0;
+#endif
+
+    assert(retAddrAP);
+    assert(qIndex < hintCacheHierNChildrenQs());
+
+#if USE_DYNAMIC_HIERARCHY
+    return hintCachePlaxGetChildAddrs(qIndex, retAddrAP);
+#else
+    assert(qIndex == 0);
+    for (p = getFirstPeer(); p; p = getNextPeer(p)) {
+	nchildren++;
+    }
+    *retAddrAP = (struct sockaddr_in *) xmalloc(nchildren
+	* sizeof(struct sockaddr_in));
+    for (p = getFirstPeer(); p; p = getNextPeer(p)) {
+	(*retAddrAP)[count] = p->in_addr;
+	count++;
+    }
+    /*
+     * Squid promises that we run atomically
+     */
+    assert(count == nchildren);
+    return nchildren;
+#endif
+}
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheHierNParentQs --
+ *
+ *          How many different message queues are they for different
+ *          parents?
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *--------------------------------------------------4.10.1998---------
+ */
+int
+hintCacheHierNParentQs(void)
+{
+#if USE_DYNAMIC_HIERARCHY
+    return hintCachePlaxNParentQs();
+#else
+    /*
+     * For static algorithm, we have one parent
+     * thus one outgoing parent buffer with index 0.
+     */
+    return 1;
+#endif
+}
+
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheHierParentQIndex --
+ *
+ *          Return the index of the queue I should use to talk
+ *          to the parent for the specified object (set amIRoot
+ *          if I am the root for the object.)
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *---------------------------------------------------4.10.1998---------
+ */
+int
+hintCacheHierParentQIndex(URLKey * key, int *amIRoot)
+{
+    assert(amIRoot != NULL);
+#if USE_DYNAMIC_HIERARCHY
+    return hintCachePlaxParentQIndex(key, amIRoot);
+#else
+    /*
+     * For static algorithm, we have one parent
+     * thus one outgoing parent buffer with index 0.
+     */
+    *amIRoot = 0;
+    return 0;
+#endif
+}
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheHierGetParentAddr --
+ *
+ *          Return the address of the node that is curerntly
+ *          the parent for the specified message queue.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      Put answer in *retAddr and return nonzero on error.
+ *
+ * Side effects:
+ *      None.
+ *
+ *-----------------------------------------------------4.10.1998-------
+ */
+int
+hintCacheHierGetParentAddr(int index, struct sockaddr_in *retAddr)
+{
+#if USE_DYNAMIC_HIERARCHY
+    return hintCachePlaxGetParentAddr(index, retAddr);
+#else
+    peer *p;
+
+    for (p = getFirstPeer(); p; p = getNextPeer(p)) {
+	if (p->type == PEER_PARENT) {
+	    *retAddr = p->in_addr;
+	    return 0;
+	}
+    }
+    p = getFirstPeer();
+    if (p) {
+	*retAddr = p->in_addr;
+	return 0;
+    }
+    return -1;
+#endif
+}
+
+
+int
+hintCacheHierSendToParent(struct sockaddr_in *src, HintCacheUpdate * update, int msgtype)
+{
+#if USE_DYNAMIC_HIERARCHY
+    int stillHave;
+    int pIndex, cIndex;
+    int iAmRoot, iAmLeaf;
+#else
+    peer *e;
+#endif
+
+#if USE_DYNAMIC_HIERARCHY
+    pIndex = hintCacheHierParentQIndex(&update->entry.key, &iAmRoot);
+#else
+    for (e = getFirstPeer(); e; e = getNextPeer(e)) {
+	if (e->type != PEER_PARENT)
+	    continue;
+	if (e->in_addr.sin_addr.s_addr == src->sin_addr.s_addr
+	    && e->http_port == src->sin_port) {
+	    if (e->type != PEER_PARENT) {
+		debug(HCHIER_DEBUG, 0,
+		    "warning: got parental msg from non-parent <%s,%d>.\n",
+		    inet_ntoa(src->sin_addr), src->sin_port);
+		debug(HCHIER_DEBUG, 0,
+		    "    Not propagating it.  Configuration mismatch?\n");
+		return (-1);
+	    }
+	    continue;
+	}
+	hintCacheNetEnqueue(&e->hcoutq, msgtype, &update->entry,
+	    update->hopcount + 1);
+    }
+    if (e == 0) {
+	/* Not found. */
+	return (-1);
+	/* Don't propagate */
+    }
+#endif
+
+#if USE_DYNAMIC_HIERARCHY
+    /* Send message */
+    if (!iAmRoot) {
+	assert(pIndex < hintCacheHier_NParentQs());
+	hintCacheNetEnqueue(&parentOutgoingA[pIndex], msgtype, &update->entry,
+	    update->hopcount + 1);
+    }
+#endif
+
+    return (0);
+}
+
+
+
+int
+hintCacheHierSendToSiblings(struct sockaddr_in *src, HintCacheUpdate * update,
+    int msgtype, int siblingtype)
+{
+#if USE_DYNAMIC_HIERARCHY
+    int stillHave;
+    int pIndex, cIndex;
+    int iAmRoot, iAmLeaf;
+#else
+    peer *e;
+#endif
+
+#if USE_DYNAMIC_HIERARCHY
+    pIndex = hintCacheHierParentQIndex(&update->entry.key, &iAmRoot);
+    cIndex = hintCacheHierChildQIndex(&update->entry.key, iAmRoot, &iAmLeaf);
+    if (!iAmLeaf) {
+	assert(cIndex < hintCacheHierNChildrenQs());
+	hintCacheNetEnqueue(&childrenOutgoingA[cIndex], msgtype,
+	    &update->entry, update->hopcount + 1);
+    }
+#else
+    for (e = getFirstPeer(); e; e = getNextPeer(e)) {
+	if (e->in_addr.sin_addr.s_addr != src->sin_addr.s_addr
+	    || e->http_port != src->sin_port) {
+	    if (siblingtype == PEER_NONE || e->type == siblingtype)
+		hintCacheNetEnqueue(&e->hcoutq, msgtype, &update->entry,
+		    update->hopcount + 1);
+	}
+    }
+#endif
+    return (0);
+}
+
+
